package com.twomee.appear2meedemo;

/**
 * Created by 2Mee Ltd on 08/06/17.
 */


import android.content.DialogInterface;
import android.os.Bundle;
import com.google.android.material.floatingactionbutton.FloatingActionButton;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.twomee.appear2mee.Appear2mee;

import java.util.Map;


public class TagsActivity extends AppCompatActivity {

    private EditText tagNameEditText;
    private EditText tagValueEditText;
    private ListView tagsList;
    private TagsAdapter tagsAdapter;
    private Map<String,String> mytags;

    private static final String TAG = "TagsListActivity";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_tags);
        FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fab);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                addChannel(null,null);
            }
        });
        tagsList = (ListView) findViewById(R.id.tagsList);
        mytags = Appear2mee.getTags();
        updateTags();
        tagsList.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position,long arg3) {
                TextView name = view.findViewWithTag("name");
                TextView value = view.findViewWithTag("value");
                String txtname = String.valueOf(name.getText());
                String txtval = String.valueOf(value.getText());

                    Log.i(TAG,"Clicked " + txtname + " " + txtval);
                    addChannel(txtname,txtval);

            }
        });
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        Appear2mee.registerTags(mytags);
    }

    @Override
    protected void onResume() {
        super.onResume();
        updateTags();
    }


    public void updateTags(){
        if (mytags != null) {
            tagsAdapter = new TagsAdapter(mytags);
            tagsList.setAdapter(tagsAdapter);
        }
    }

    private void addChannel(String key, String value) {
        AlertDialog.Builder _addTag = new AlertDialog.Builder(this);
        String title = "Add Tag";
        String btnText = "Add";
        final String deleteKey = key;
        Boolean allowDelete = false;
        if(key != null || value != null)  {
            title = "Change Tag";
            btnText = "Change";
            allowDelete = true;
        }
        _addTag.setTitle(title);
        _addTag.setView(R.layout.layout_add_tag);

        _addTag.setPositiveButton(btnText, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialogInterface, int i) {
                String text = tagNameEditText.getText().toString();
                String value = tagValueEditText.getText().toString();
                if (text.length() != 0 && value.length() != 0) {
                    mytags.put(text,value);
                    dialogInterface.cancel();
                    updateTags();
                } else {
                    Toast.makeText(TagsActivity.this, "Please enter tag key/value", Toast.LENGTH_SHORT).show();
                }
            }
        });

        _addTag.setNeutralButton("Cancel", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialogInterface, int i) {
                dialogInterface.cancel();
            }
        });

        if(allowDelete) {
            _addTag.setNegativeButton("Delete", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialogInterface, int i) {
                    String text = tagNameEditText.getText().toString();
                    mytags.remove(deleteKey);
                    dialogInterface.cancel();
                    updateTags();


                }
            });
        }

        AlertDialog alertDialog = _addTag.create();
        alertDialog.show();
        tagNameEditText = (EditText) alertDialog.findViewById(R.id.tagName);
        tagValueEditText = (EditText) alertDialog.findViewById(R.id.tagValue);
        if(key != null) {
            tagNameEditText.setText(key);
        }
        if(value != null) {
            tagValueEditText.setText(value);
        }
    }

}
